local exports = exports or {}
local frame0 = require("src.frame.frame")
local Frame = frame0.Frame
local PaintFunction = frame0.PaintFunction
local position1 = require("src.frame.position")
local Position = position1.Position
local FixedPosition = position1.FixedPosition
local LayoutPosition = position1.LayoutPosition
local XAlign = position1.XAlign
local YAlign = position1.YAlign
local size2 = require("src.frame.size")
local Size = size2.Size
local window3 = require("src.frame.window")
local Window = window3.Window
local layout4 = require("src.frame.layout")
local Layout = layout4.Layout
local ColumnLayout = layout4.ColumnLayout
local RowLayout = layout4.RowLayout
local NoChildLayout = layout4.NoChildLayout
local GridLayout = layout4.GridLayout
local rectangle5 = require("src.painter.rectangle")
local RectanglePainter = rectangle5.RectanglePainter
local label6 = require("src.painter.label")
local LabelPainter = label6.LabelPainter
local group7 = require("src.painter.group")
local GroupPainter = group7.GroupPainter
local color8 = require("src.painter.color")
local Colors = color8.Colors
local Button = Button or Frame.new()
Button.__index = Button
Button.__base = Frame
function Button.new(construct, ...)
    local self = setmetatable({}, Button)
    if construct and Button.constructor then Button.constructor(self, ...) end
    return self
end
function Button.constructor(self,id,pos,size,parent,defaultPainter,selectedPainter,activePainter,action)
    Button.__base.constructor(self,pos,size,parent,NoChildLayout.new(true),defaultPainter,function(self,x,y)
        self.paint = self.activePainter;
    end
,function(self)
        if self.selected then
            self.paint = self.selectedPainter;
        end
        do 
            self.paint = self.defaultPainter;
end

        self.action(self.id);
    end
);
    self.selected = false;
    self.defaultPainter = defaultPainter;
    self.selectedPainter = selectedPainter;
    self.activePainter = activePainter;
    self.action = action;
    self.id = id;
end
function Button.setSelected(self,s)
    self.selected = s;
    if (self.paint==self.defaultPainter) and s then
        self.paint = self.selectedPainter;
    elseif (self.paint==self.selectedPainter) and (not s) then
        self.paint = self.defaultPainter;
    end
end
local GroupButton = GroupButton or {}
GroupButton.__index = GroupButton
function GroupButton.new(construct, ...)
    local self = setmetatable({}, GroupButton)
    if construct and GroupButton.constructor then GroupButton.constructor(self, ...) end
    return self
end
function GroupButton.constructor(self,btns)
    self.btns = btns;
    self.selected = "";
end
function GroupButton.select(self,btnId)
    self.selected = btnId;
    local i = 0
    while(i<#self.btns) do
        do
            self.btns[(i)+1]:setSelected(self.btns[(i)+1].id==btnId);
        end
        ::__continue0::
        i = (i+1)
    end
end
exports.Button = Button
exports.GroupButton = GroupButton
return exports
